<%@ Control Language="C#" AutoEventWireup="true" CodeFile="AdvancedFormCS.ascx.cs"
    Inherits="SchedulerTemplatesCS.AdvancedForm" %>
<%@ Register TagPrefix="telerik" Namespace="Telerik.Web.UI" Assembly="Telerik.Web.UI" %>
<%@ Register TagPrefix="scheduler" TagName="ResourceControl" Src="ResourceControlCS.ascx" %>
<%@ Register TagPrefix="scheduler" TagName="MultipleValuesResourceControl" Src="MultipleValuesResourceControlCS.ascx" %>
<div class="rsAdvancedEdit" style="position: relative">
    <%-- Title bar. --%>
    <div class="rsAdvTitle">
        <%-- The rsAdvInnerTitle element is used as a drag handle when the form is modal. --%>
        <h1 class="rsAdvInnerTitle">
            <%= Owner.Localization.AdvancedEditAppointment %></h1>
        <asp:LinkButton runat="server" ID="AdvancedEditCloseButton" CssClass="rsAdvEditClose"
            CommandName="Cancel" CausesValidation="false" ToolTip='<%# Owner.Localization.AdvancedClose %>'>
			<%= Owner.Localization.AdvancedClose %>
        </asp:LinkButton>
    </div>
    <div class="rsAdvContentWrapper">
        <%-- Scroll container - when the form height exceeds MaximumHeight scrollbars will appear on this element--%>
        <div class="rsAdvOptionsScroll">
            <asp:Panel runat="server" ID="AdvancedEditOptionsPanel" CssClass="rsAdvOptions">
                <asp:Panel runat="server" ID="BasicControlsPanel" CssClass="rsAdvBasicControls" OnDataBinding="BasicControlsPanel_DataBinding">
                    <telerik:RadTextBox runat="server" ID="SubjectText" Width="100%" Label='<%# Owner.Localization.AdvancedSubject + ":" %>'
                        Text='<%# Eval("Subject") %>' />
                    <asp:RequiredFieldValidator runat="server" ID="SubjectValidator" ControlToValidate="SubjectText"
                        EnableClientScript="true" Display="None" CssClass="rsValidatorMsg" />
                    <ul class="rsTimePickers">
                        <li class="rsTimePick">
                            <label for='<%= StartDate.ClientID %>_dateInput_text'>
                                <%= Owner.Localization.AdvancedFrom %></label><%--
							    Leaving a newline here will affect the layout, so we use a comment instead.
							--%><telerik:RadDatePicker runat="server" ID="StartDate" CssClass="rsAdvDatePicker"
                                Width="83px" SharedCalendarID="SharedCalendar" Skin='<%# Owner.Skin %>' Culture='<%# Owner.Culture %>'
                                MinDate="1900-01-01">
                                <DatePopupButton Visible="False" />
                                <DateInput ID="DateInput2" runat="server" DateFormat='<%# Owner.AdvancedForm.DateFormat %>'
                                    EmptyMessageStyle-CssClass="radInvalidCss_Default" EmptyMessage=" " />
                            </telerik:RadDatePicker>
                            <%--
							
							--%><telerik:RadTimePicker runat="server" ID="StartTime" CssClass="rsAdvTimePicker"
                                Width="65px" Skin='<%# Owner.Skin %>' Culture='<%# Owner.Culture %>'>
                                <DateInput ID="DateInput3" runat="server" EmptyMessageStyle-CssClass="radInvalidCss_Default"
                                    EmptyMessage=" " />
                                <TimePopupButton Visible="false" />
                                <TimeView ID="TimeView1" runat="server" Columns="2" ShowHeader="false" StartTime="08:00"
                                    EndTime="18:00" Interval="00:30" />
                            </telerik:RadTimePicker>
                        </li>
                        <li class="rsTimePick">
                            <label for='<%= EndDate.ClientID %>_dateInput_text'>
                                <%= Owner.Localization.AdvancedTo%></label><%--
							
							--%><telerik:RadDatePicker runat="server" ID="EndDate" CssClass="rsAdvDatePicker"
                                Width="83px" SharedCalendarID="SharedCalendar" Skin='<%# Owner.Skin %>' Culture='<%# Owner.Culture %>'
                                MinDate="1900-01-01">
                                <DatePopupButton Visible="False" />
                                <DateInput ID="DateInput4" runat="server" DateFormat='<%# Owner.AdvancedForm.DateFormat %>'
                                    EmptyMessageStyle-CssClass="radInvalidCss_Default" EmptyMessage=" " />
                            </telerik:RadDatePicker>
                            <%--
							
							--%><telerik:RadTimePicker runat="server" ID="EndTime" CssClass="rsAdvTimePicker"
                                Width="65px" Skin='<%# Owner.Skin %>' Culture='<%# Owner.Culture %>'>
                                <DateInput ID="DateInput5" runat="server" EmptyMessageStyle-CssClass="radInvalidCss_Default"
                                    EmptyMessage=" " />
                                <TimePopupButton Visible="false" />
                                <TimeView ID="TimeView2" runat="server" Columns="2" ShowHeader="false" StartTime="08:00"
                                    EndTime="18:00" Interval="00:30" />
                            </telerik:RadTimePicker>
                        </li>
                        <li class="rsAllDayWrapper">
                            <asp:CheckBox runat="server" ID="AllDayEvent" CssClass="rsAdvChkWrap" Checked="false" />
                        </li>
                    </ul>
                    <asp:RequiredFieldValidator runat="server" ID="StartDateValidator" ControlToValidate="StartDate"
                        EnableClientScript="true" Display="None" CssClass="rsValidatorMsg" />
                    <asp:RequiredFieldValidator runat="server" ID="StartTimeValidator" ControlToValidate="StartTime"
                        EnableClientScript="true" Display="None" CssClass="rsValidatorMsg" />
                    <asp:RequiredFieldValidator runat="server" ID="EndDateValidator" ControlToValidate="EndDate"
                        EnableClientScript="true" Display="None" CssClass="rsValidatorMsg" />
                    <asp:RequiredFieldValidator runat="server" ID="EndTimeValidator" ControlToValidate="EndTime"
                        EnableClientScript="true" Display="None" CssClass="rsValidatorMsg" />
                    <asp:CustomValidator runat="server" ID="DurationValidator" ControlToValidate="StartDate"
                        EnableClientScript="false" Display="Dynamic" CssClass="rsValidatorMsg rsInvalid"
                        OnServerValidate="DurationValidator_OnServerValidate" />
                </asp:Panel>
                <asp:Panel runat="server" ID="UploadPanel" CssClass="rsUploadPanel">
                    Attachments:
                    <%= Attachment %>
                    <telerik:RadUpload runat="server" ID="RadUpload1" ControlObjectsVisibility="RemoveButtons,AddButton"
                        TargetFolder="~/Attachments">
                    </telerik:RadUpload>
                    <asp:Button runat="server" ID="SubmitButton" Text="Submit" CssClass="rsSubmitButton" />
                </asp:Panel>
                <telerik:RadTextBox runat="server" ID="DescriptionText" TextMode="MultiLine" Columns="50"
                    Rows="5" Width="100%" Label='<%# Owner.Localization.AdvancedDescription + ":" %>'
                    Text='<%# Eval("Description") %>' />
                <asp:Panel runat="server" ID="RecurrenceCheckBoxPanel">
                    <asp:CheckBox runat="server" ID="RecurrentAppointment" CssClass="rsAdvChkWrap" Checked="false"
                        Style="float: none" />
                </asp:Panel>
                <asp:Panel ID="additionalPanel" runat="server">
                    <asp:TextBox runat="server" ID="tbSearchContacts"></asp:TextBox>
                    <asp:Button runat="server" ID="btnSearchContacts" Text="Search Contacts" OnClick="btnSearchContacts_Click" /><br />
                    <asp:CheckBoxList ID="cblContacts" runat="server" />
                    <asp:Button runat="server" ID="btnUseContacts" Visible="false" Text="Use Contacts"
                        OnClick="btnUseContacts_Click" Style="width: 119px" />
                </asp:Panel>
                <asp:Panel runat="server" ID="RecurrencePanel" Style="display: none;" CssClass="rsAdvRecurrencePanel">
                    <asp:Panel runat="server" ID="RecurrencePatternPanel" CssClass="rsAdvRecurrencePatterns"
                        OnDataBinding="RecurrencePatternPanel_DataBinding">
                        <span class="rsAdvResetExceptions">
                            <asp:LinkButton runat="server" ID="ResetExceptions" OnClick="ResetExceptions_OnClick" />
                        </span>
                        <asp:Panel runat="server" ID="RecurrenceFrequencyPanel" CssClass="rsAdvRecurrenceFreq">
                            <ul class="rsRecurrenceOptionList">
                                <li>
                                    <asp:RadioButton runat="server" GroupName="RepeatFrequency" ID="RepeatFrequencyHourly" /></li>
                                <li>
                                    <asp:RadioButton runat="server" GroupName="RepeatFrequency" ID="RepeatFrequencyDaily" /></li>
                                <li>
                                    <asp:RadioButton runat="server" GroupName="RepeatFrequency" ID="RepeatFrequencyWeekly" /></li>
                                <li>
                                    <asp:RadioButton runat="server" GroupName="RepeatFrequency" ID="RepeatFrequencyMonthly" /></li>
                                <li>
                                    <asp:RadioButton runat="server" GroupName="RepeatFrequency" ID="RepeatFrequencyYearly" /></li>
                            </ul>
                        </asp:Panel>
                        <asp:Panel runat="server" ID="RecurrencePatternHourlyPanel" CssClass="rsAdvPatternPanel rsAdvHourly"
                            Style="display: none;">
                            <div>
                                <%= Owner.Localization.AdvancedEvery %>
                                <telerik:RadNumericTextBox runat="server" CssClass="rsAdvInput" Width="50px" ID="HourlyRepeatInterval"
                                    Value="1" Type="Number" NumberFormat-DecimalDigits="0" ShowSpinButtons="true"
                                    MinValue="1" Skin='<%# Owner.Skin %>' />
                                <%= Owner.Localization.AdvancedHours %>
                            </div>
                        </asp:Panel>
                        <asp:Panel runat="server" ID="RecurrencePatternDailyPanel" CssClass="rsAdvPatternPanel rsAdvDaily"
                            Style="display: none;">
                            <ul>
                                <li>
                                    <asp:RadioButton runat="server" ID="RepeatEveryNthDay" Checked="true" GroupName="DailyRecurrenceDetailRadioGroup"
                                        CssClass="rsAdvRadio" />
                                    <telerik:RadNumericTextBox runat="server" CssClass="rsAdvInput" Width="50px" ID="DailyRepeatInterval"
                                        Value="1" Type="Number" NumberFormat-DecimalDigits="0" ShowSpinButtons="true"
                                        MinValue="1" Skin='<%# Owner.Skin %>' />
                                    <%= Owner.Localization.AdvancedDays %>
                                </li>
                                <li>
                                    <asp:RadioButton runat="server" ID="RepeatEveryWeekday" GroupName="DailyRecurrenceDetailRadioGroup"
                                        CssClass="rsAdvRadio" />
                                </li>
                            </ul>
                        </asp:Panel>
                        <asp:Panel runat="server" ID="RecurrencePatternWeeklyPanel" CssClass="rsAdvPatternPanel rsAdvWeekly"
                            Style="display: none;">
                            <div>
                                <%= Owner.Localization.AdvancedRecurEvery %>
                                <telerik:RadNumericTextBox runat="server" CssClass="rsAdvInput" Width="50px" ID="WeeklyRepeatInterval"
                                    Value="1" Type="Number" NumberFormat-DecimalDigits="0" ShowSpinButtons="true"
                                    MinValue="1" Skin='<%# Owner.Skin %>' />
                                <%= Owner.Localization.AdvancedWeeks %>
                            </div>
                            <ul class="rsAdvWeekly_WeekDays">
                                <li>
                                    <asp:CheckBox runat="server" CssClass="rsAdvCheckboxWrapper" ID="WeeklyWeekDaySunday" /></li>
                                <li>
                                    <asp:CheckBox runat="server" CssClass="rsAdvCheckboxWrapper" ID="WeeklyWeekDayMonday" /></li>
                                <li>
                                    <asp:CheckBox runat="server" CssClass="rsAdvCheckboxWrapper" ID="WeeklyWeekDayTuesday" /></li>
                                <li>
                                    <asp:CheckBox runat="server" CssClass="rsAdvCheckboxWrapper" ID="WeeklyWeekDayWednesday" /></li>
                                <li style="clear: left;">
                                    <asp:CheckBox runat="server" CssClass="rsAdvCheckboxWrapper" ID="WeeklyWeekDayThursday" /></li>
                                <li>
                                    <asp:CheckBox runat="server" CssClass="rsAdvCheckboxWrapper" ID="WeeklyWeekDayFriday" /></li>
                                <li>
                                    <asp:CheckBox runat="server" CssClass="rsAdvCheckboxWrapper" ID="WeeklyWeekDaySaturday" /></li>
                            </ul>
                        </asp:Panel>
                        <asp:Panel runat="server" ID="RecurrencePatternMonthlyPanel" CssClass="rsAdvPatternPanel rsAdvMonthly"
                            Style="display: none;">
                            <ul>
                                <li>
                                    <asp:RadioButton runat="server" ID="RepeatEveryNthMonthOnDate" Checked="true" GroupName="MonthlyRecurrenceRadioGroup"
                                        CssClass="rsAdvRadio" />
                                    <telerik:RadNumericTextBox runat="server" CssClass="rsAdvInput" Width="50px" ID="MonthlyRepeatDate"
                                        Value="1" Type="Number" NumberFormat-DecimalDigits="0" ShowSpinButtons="true"
                                        MinValue="1" MaxValue="31" Skin='<%# Owner.Skin %>' />
                                    <%= Owner.Localization.AdvancedOfEvery %>
                                    <telerik:RadNumericTextBox runat="server" CssClass="rsAdvInput" Width="50px" ID="MonthlyRepeatIntervalForDate"
                                        Value="1" Type="Number" NumberFormat-DecimalDigits="0" ShowSpinButtons="true"
                                        MinValue="1" Skin='<%# Owner.Skin %>' />
                                    <%= Owner.Localization.AdvancedMonths %>
                                </li>
                                <li>
                                    <asp:RadioButton runat="server" ID="RepeatEveryNthMonthOnGivenDay" GroupName="MonthlyRecurrenceRadioGroup"
                                        CssClass="rsAdvRadio" />
                                    <telerik:RadComboBox runat="server" ID="MonthlyDayOrdinalDropDown" Width="70px" Skin='<%# Owner.Skin %>'
                                        CssClass="rsAdvRecurrenceDropDown">
                                        <%--Populated from code-behind--%>
                                    </telerik:RadComboBox>
                                    <telerik:RadComboBox runat="server" ID="MonthlyDayMaskDropDown" Width="110px" Skin='<%# Owner.Skin %>'
                                        CssClass="rsAdvRecurrenceDropDown">
                                        <%--Populated from code-behind--%>
                                    </telerik:RadComboBox>
                                    <%= Owner.Localization.AdvancedOfEvery %>
                                    <telerik:RadNumericTextBox runat="server" CssClass="rsAdvInput" Width="50px" ID="MonthlyRepeatIntervalForGivenDay"
                                        Value="1" Type="Number" NumberFormat-DecimalDigits="0" ShowSpinButtons="true"
                                        MinValue="1" Skin='<%# Owner.Skin %>' />
                                    <%= Owner.Localization.AdvancedMonths %>
                                </li>
                            </ul>
                        </asp:Panel>
                        <asp:Panel runat="server" ID="RecurrencePatternYearlyPanel" CssClass="rsAdvPatternPanel rsAdvYearly"
                            Style="display: none;">
                            <ul>
                                <li>
                                    <asp:RadioButton runat="server" ID="RepeatEveryYearOnDate" Checked="true" GroupName="YearlyRecurrenceRadioGroup"
                                        CssClass="rsAdvRadio" />
                                    <telerik:RadComboBox runat="server" ID="YearlyRepeatMonthForDate" Width="90px" Skin='<%# Owner.Skin %>'>
                                        <%--Populated from code-behind--%>
                                    </telerik:RadComboBox>
                                    <telerik:RadNumericTextBox runat="server" CssClass="rsAdvInput" Width="50px" ID="YearlyRepeatDate"
                                        Value="1" Type="Number" NumberFormat-DecimalDigits="0" ShowSpinButtons="true"
                                        MinValue="1" MaxValue="31" Skin='<%# Owner.Skin %>' />
                                </li>
                                <li>
                                    <asp:RadioButton runat="server" ID="RepeatEveryYearOnGivenDay" GroupName="YearlyRecurrenceRadioGroup"
                                        CssClass="rsAdvRadio" />
                                    <telerik:RadComboBox runat="server" ID="YearlyDayOrdinalDropDown" Width="70px" Skin='<%# Owner.Skin %>'
                                        CssClass="rsAdvRecurrenceDropDown">
                                        <%--Populated from code-behind--%>
                                    </telerik:RadComboBox>
                                    <telerik:RadComboBox runat="server" ID="YearlyDayMaskDropDown" Width="110px" Skin='<%# Owner.Skin %>'
                                        CssClass="rsAdvRecurrenceDropDown">
                                        <%--Populated from code-behind--%>
                                    </telerik:RadComboBox>
                                    <%= Owner.Localization.AdvancedOf %>
                                    <telerik:RadComboBox runat="server" ID="YearlyRepeatMonthForGivenDay" Width="90px"
                                        Skin='<%# Owner.Skin %>'>
                                        <%--Populated from code-behind--%>
                                    </telerik:RadComboBox>
                                </li>
                            </ul>
                        </asp:Panel>
                    </asp:Panel>
                    <asp:Panel runat="server" ID="RecurrenceRangePanel" CssClass="rsAdvRecurrenceRangePanel"
                        OnDataBinding="RecurrenceRangePanel_DataBinding">
                        <ul>
                            <li>
                                <asp:RadioButton runat="server" ID="RepeatIndefinitely" Checked="true" GroupName="RecurrenceRangeRadioGroup"
                                    CssClass="rsAdvRadio" />
                            </li>
                            <li>
                                <asp:RadioButton runat="server" ID="RepeatGivenOccurrences" GroupName="RecurrenceRangeRadioGroup"
                                    CssClass="rsAdvRadio" />
                                <telerik:RadNumericTextBox runat="server" CssClass="rsAdvInput" Width="50px" ID="RangeOccurrences"
                                    Type="Number" NumberFormat-DecimalDigits="0" ShowSpinButtons="true" MinValue="1"
                                    Skin='<%# Owner.Skin %>' />
                                <%= Owner.Localization.AdvancedOccurrences %>
                            </li>
                            <li class="rsTimePick">
                                <asp:RadioButton runat="server" ID="RepeatUntilGivenDate" GroupName="RecurrenceRangeRadioGroup"
                                    CssClass="rsAdvRadio" />
                                <telerik:RadDatePicker runat="server" ID="RangeEndDate" CssClass="rsAdvDatePicker"
                                    Width="83px" Skin='<%# Owner.Skin %>' SharedCalendarID="SharedCalendar" Culture='<%# Owner.Culture %>'>
                                    <DatePopupButton Visible="False" />
                                    <DateInput ID="DateInput1" runat="server" DateFormat='<%# Owner.AdvancedForm.DateFormat %>' />
                                </telerik:RadDatePicker>
                            </li>
                        </ul>
                    </asp:Panel>
                </asp:Panel>
                <asp:HiddenField runat="server" ID="OriginalRecurrenceRule" />
                <telerik:RadCalendar runat="server" ID="SharedCalendar" Skin='<%# Owner.Skin %>'
                    CultureInfo='<%# Owner.Culture %>' ShowRowHeaders="false" RangeMinDate="1900-01-01" />
            </asp:Panel>
        </div>
        <asp:Panel runat="server" ID="ButtonsPanel" CssClass="rsAdvancedSubmitArea">
            <div class="rsAdvButtonWrapper">
                <asp:LinkButton runat="server" ID="UpdateButton" CssClass="rsAdvEditSave">
					<span><%= Owner.Localization.Save %></span>
                </asp:LinkButton>
                <asp:LinkButton runat="server" ID="CancelButton" CssClass="rsAdvEditCancel" CommandName="Cancel"
                    CausesValidation="false">
					<span><%= Owner.Localization.Cancel %></span>
                </asp:LinkButton>
            </div>
        </asp:Panel>
    </div>
</div>
